class Shape {
    draw() {
        console.log("shape is drawing");
    }
}
class Component {
    display() {
        console.log("component is displaying");
    }
}
class Rectangle {
    constructor(w, h) {
        this.w = w;
        this.h = h;
    }
    area() {
        return this.w * this.h;
    }
    //just provide the empty implementation which will be replaced by the mixins helper function
    //same as display: () => void
    display() {
    }
    //same as draw: () => void
    draw() {
    }
}
//applying mixing which iterates through properties of baseCtors classes  and copy them to the target class (derivedCtor)
function applyMixins(derivedCtor, baseCtors) {
    baseCtors.forEach(baseCtor => {
        Object.getOwnPropertyNames(baseCtor.prototype).forEach(name => {
            Object.defineProperty(derivedCtor.prototype, name, Object.getOwnPropertyDescriptor(baseCtor.prototype, name));
        });
    });
}
applyMixins(Rectangle, [Shape, Component]);
let rectangle = new Rectangle(4, 3);
rectangle.draw();
rectangle.display();
let area = rectangle.area();
console.log(area);